<?php

/**
 * PHPDevShell is a RAD Framework aimed at developing administrative applications.
 *
 * @package PHPDevShell
 * @link http://www.phpdevshell.org
 * @copyright Copyright (C) 2007 Jason Schoeman, All rights reserved.
 * @license GNU/LGPL, see readme/licensed_under_lgpl or http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 *
 * Copyright notice: See readme/notice
 * By using PHPDevShell you agree to notice and license, if you dont agree to this notice/license you are not allowed to use PHPDevShell.
 */
class CronjobAdminList extends PHPDS_controller
{

	/**
	 * Simply optimizes Database.
	 * @author Jason Schoeman [titan@phpdevshell.org], Ross Kuyper
	 * @since 24 June 2010
	 */
	public function execute()
	{
		$this->template->heading(_('Cronjobs Admin'));
		$this->template->info(_('Manage existing cronjobs. a Cronjob touches a script to run without human intervention on a specified time cycle, this is mostly used to run maintenance scripts. It will always run when manually triggered.'));

		// Delete broken cron item.
		if (!empty($this->security->get['dc']) && $this->user->isRoot()) {
			if ($this->db->deleteQuick('_db_core_cron', 'menu_id', $this->security->get['dc'])) {
				$this->template->ok(sprintf(_('Orphan item %s was deleted.'), $this->security->get['dc']));
			} else {
				$this->template->warning(sprintf(_('No orphan cron "%s" to delete.'), $this->security->get['dc']));
			}
		}

		$so = $this->navigation->buildURL(false, 'so=');
		if (!empty($this->security->get['so']) && $this->security->get['so'] == 'true') {
			$orphan_sql = false;
			$show_orphans = "<a href=\"{$so}false\">" . _('(Show Crons)') . "</a>";
		} else {
			$orphan_sql = true;
			$show_orphans = "<a href=\"{$so}true\">" . _('(Find Orphans)') . "</a>";
		}

		$RESULTS = $this->db->invokeQuery('PHPDS_listCronjobAdminQuery', $orphan_sql);

		// Load views.
		$view = $this->factory('views');

		// Set Array.
		$view->set('RESULTS', $RESULTS);

		// Set Values.
		$view->set('show_orphans', $show_orphans);

		// Output Template.
		$view->show();
	}
}

return 'CronjobAdminList';