<?php

/**
 * PHPDevShell is a RAD Framework aimed at developing administrative applications.
 *
 * @package PHPDevShell
 * @link http://www.phpdevshell.org
 * @copyright Copyright (C) 2007 Jason Schoeman, All rights reserved.
 * @license GNU/LGPL, see readme/licensed_under_lgpl or http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 *
 * Copyright notice: See readme/notice
 * By using PHPDevShell you agree to notice and license, if you dont agree to this notice/license you are not allowed to use PHPDevShell.
 */
class OptimizeDatabase extends PHPDS_controller
{

	/**
	 * Simply optimizes Database.
	 * @author Greg
	 * @since 24 June 2010
	 */
	public function execute()
	{
		$this->template->heading(_('Optimize Database'));
		$this->template->info(_('Does a table repair and a key analysis, and also sorts the index tree so that key lookups are faster.'));
		// Get all tables from database.
		$all_tables = $this->db->invokeQuery('PHPDS_fetchTablesToOptimizeQuery', $this->configuration['database_name']);

		// Optimize the tables
		$RESULTS = $this->db->invokeQuery('PHPDS_optimizeTablesQuery', $all_tables);
		// Load views.
		$view = $this->factory('views');

		// Set Array.
		$view->set('RESULTS', $RESULTS);

		// Output Template.
		$view->show();
	}
}

return 'OptimizeDatabase';