<?php

/**
 * PHPDevShell is a RAD Framework aimed at developing administrative applications.
 *
 * @package PHPDevShell
 * @link http://www.phpdevshell.org
 * @copyright Copyright (C) 2007 Jason Schoeman, All rights reserved.
 * @license GNU/LGPL, see readme/licensed_under_lgpl or http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 *
 * Copyright notice: See readme/notice
 * By using PHPDevShell you agree to notice and license, if you dont agree to this notice/license you are not allowed to use PHPDevShell.
 */

/**
 * Config Manager: Simple and effective way in handling settings in a registry type format.
 * @author Jason Schoeman
 * @return string
 */
class ConfigManager extends PHPDS_controller
{

	/**
	 * Execute Controller
	 * @author Jason Schoeman
	 */
	public function execute()
	{
		$this->template->heading(_('Configuration Manager'));
		$this->template->info(_('Allows you to manage all configuration settings per plugin.'));

		// Action url.
		$self_url_ = $this->navigation->buildURL(false);
		// Should we delete a setting?
		if (!empty($this->security->get['ds'])) {
			// Lets delete the entry.
			$this->db->deleteQuick('_db_core_settings', 'setting_description', $this->security->get['ds']);

			// Show ok deleted.
			$this->template->ok(sprintf(_('Deleted setting entry %s.'), $this->security->get['ds']));
		}
		// We have a save action, lets handle it.
		if (! empty($this->security->post['save'])) {
			// Write new setting.
			$write_sd = '';
			if (!empty($this->security->post['setting_description_'])) {
				$write_sd .= "('{$this->security->post['setting_description_']}', '{$this->security->post['setting_value_']}'),";
			}
			// Write everything else.
			if (! empty($this->security->post['setting_description'])) {
				foreach ($this->security->post['setting_description'] as $sd) {
					if (!empty($sd)) {
						if (empty($this->security->post['setting_value'][$sd]))
								$this->security->post['setting_value'][$sd] = '';
						$write_sd .= "('$sd', '{$this->security->post['setting_value'][$sd]}'),";
					}
				}
			}
			// Do we have anything to write to database.
			if (!empty($write_sd)) {
				// Prepare write.
				$write_sd = rtrim($write_sd, ',');
				// Write to DB.
				if ($this->db->invokeQuery('PHPDS_writeCoreSettingsQuery', $write_sd)) {
					$this->template->ok(_('Plugin settings was saved.'));
				}
			} else {
				$this->template->warning(_('No plugin settings was saved.'));
			}
		}
		// Lets create the list of all the entries.
		$RESULTS = $this->db->invokeQuery('PHPDS_readCoreSettingsQuery');

		// Load views.
		$view = $this->factory('views');

		// Set Values to Template.
		$view->set('pagination', $RESULTS['pagination']);
		$view->set('searchForm', $RESULTS['searchForm']);
		$view->set('th', $RESULTS['th']);
		$view->set('RESULTS', $RESULTS['list']);
		$view->set('self_url', $self_url_);

		// Call template.
		$view->show();
	}
}

return 'ConfigManager';