<?php
/**
 * PHPDevShell is a RAD Framework aimed at developing administrative applications.
 *
 * @package PHPDevShell
 * @link http://www.phpdevshell.org
 * @copyright Copyright (C) 2007 Jason Schoeman, All rights reserved.
 * @license GNU/LGPL, see readme/licensed_under_lgpl or http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 * Copyright notice: See readme/notice
 * By using PHPDevShell you agree to notice and license, if you dont agree to this notice/license you are not allowed to use PHPDevShell.
 */
/**
 * Contains methods to handle pagination, searching and filtering.
 * PHPMailer could also be used.
 * @author Jason Schoeman
 */

/**
 * Calls filters per page regarding search.
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 */
class PAGINATION_readFilterCacheQuery extends PHPDS_query
{
    protected $sql = "
        SELECT
            t1.search_id, t1.filter_search, t1.filter_order, t1.filter_by, t1.exact_match
        FROM
            _db_core_filter t1
        WHERE
            t1.menu_id = '%s'
        AND
            t1.user_id = %u
        LIMIT
            0,1
    ";

    protected $single_row = true;
}

/**
 * Replaces current search filters.
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 */
class PAGINATION_writeFilterCacheQuery extends PHPDS_query
{
    protected $sql = "
        REPLACE INTO
            _db_core_filter
        VALUES
            (%u, %u, '%s', '%s', '%s', '%s', %u)
    ";
}

/**
 * Master query for pagination.
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 */
class PAGINATION_readPaginationQuery extends PHPDS_query
{
    protected $sql = '';

    /**
	 * Initiate query invoke command.
	 * @param int
	 * @return array
	 */
	public function invoke ($parameters)
	{
        // Get actual query.
		$this->sql = preg_replace("/select/i", 'SELECT SQL_CALC_FOUND_ROWS', $parameters[0], 1);

        if (! empty($parameters[1])) {
			$param = $parameters[1];
		} else {
			$param = array();
		}
        $results = parent::invoke($param);
		if (! empty($results)) {
			return $results;
		} else {
			return array ();
		}
    }
}

/**
 * Supportive class to count results.
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 */
class PAGINATION_readFounRowsQuery extends PHPDS_query
{
    protected $sql = 'SELECT FOUND_ROWS()';

    protected $single_value = true;
}